#define CMax 4  //  Max number of coefficients (parameters) in a model
#define SMax 15
// Structures
struct coeff {int size;double c[CMax];double error;};

struct SS 
{ 
	int D;
	double max[CMax];
	double min[CMax]; 
};

struct param 
{
  	double c;		// Confidence coefficient
  //	int clamping;	// Position clamping or not
	int K;			// Max number of particles informed by a given one
	double p;		// Probability threshold for random topology	
					// (is actually computed as p(S,K) )
	int randOrder;	// Random choice of particles or not
	int initLink; // How to re-init links
  	int S;			// Swarm size
  	int stop;		// Flag for stop criterion
  	double w;		// Confidence coefficient
};

struct velocity 
{  
	int size;  
	double v[CMax]; 
};

struct problem 
{ 
	double epsilon; 	// Admissible error
	int evalMax; 		// Maximum number of fitness evaluations
	int function; 		// Function code
	double objective; 	// Objective value
						// Solution position (if known, just for tests)	
	struct SS SS;		// Search space
};

struct swarm 
{ 
	int best; 					// rank of the best particle
	struct coeff P[SMax];	// Previous best positions found by each particle
	int S; 						// Swarm size 
	struct velocity V[SMax];	// Velocities
  	struct coeff X[SMax];	// Positions 
};

